#Need to expand for all regions, parallelize via foreach
#Ideally, this would work entirely from the daily data and
#aggregate to weekly as necessary
library("remotes")

remotes::install_gitlab("calabr29/forecastw2t", host="gitlab.hzdr.de", auth_token="nZzyUY6kp-AD51QSAqew")

library("forecastW2T")

library("ggplot2")
library("foreach")
library("doParallel")
library("remotes")
library("forecast")
library("forecastW2T")

source('F:/Research/where2test/com.casus.env.where2test.forecasting/Daily_test_Kai/Kai_functions.R')

#Register a cluster for parallelized loop
nCores <- detectCores()
cl<- makeCluster(nCores[1]-1) #not to overload your computer
registerDoParallel(cl)

setwd("F:/Research/where2test/com.casus.env.where2test.forecasting/TestSarima/")

#Weekly data
WDATA <- read.csv(file="Data/cases[RKI]_saxony_weekly.csv")

#Daily data
DDATA <- read.csv(file="Data/cases[RKI]_saxony_daily.csv")

CODES <- unique(WDATA$region)
L.CODES <- length(CODES)

#Number of obs to use when fitting/selecting ARIMA model
#The last NOBS values of the timeseries are used
#ARIMA MODELS START TO PERFORM POORLY WHEN THEY ARE FIT TO
#TOO MANY OBS. THE IDEA IS TO PREVENT THAT FROM HAPPENING
#BY ONLY USING PART OF THE TIMESERIES, BUT THERE IS NO EXACT
#BEST NOBS.
NOBS <- 100

#Number of sims. This should be large
NREP <- 10000

#This is how many days of data will be ignored at the end of the dataset
HDNC <- 4

#Length of the forecast horizon in weeks, excluding nowcast
HW <- 3

#Overall forecast horizon in days including nowcast
HD <- HW*7 + HDNC

#MODS <- data.frame(matrix(NA,nrow=L.CODES,ncol=2))
#MODS[,1] <- CODES

# DDATASET <- subset(DDATA, select=c("region", "date", "cases"))
# DDATASET$date <- as.Date(DDATASET$date)
# DDATASET <- DDATASET[DDATASET$date > as.Date('2020-09-13'),]
# 
# #Extract dates and case numbers
# DDATES <- as.Date(head(DDATASET$date, n=-6))
# DCASES <- head(DDATASET$cases, n=-6)
# 
# #Cast the case counts as a timeseries with weekly frequency
# DCASES <- ts(DCASES, start=c(2020, as.numeric(format(DDATES[1], "%j"))),
#              frequency = 7)
# 
# #Probably need to settle on a consistent arima model to use to avoid overfitting
# #Until then, use auto.arima
# #ARIMA models behave weirdly when they have too much data to chew on
# #As a pragmatic workaround, take the last 100 days for fitting/selecting the model
# #SARIMA <- auto.arima(tail(DCASES+1, n=100), approximation=F, lambda="auto", num.cores = nCores)
# 
# #ARIMA <- ets(window(DCASES+1, start=2080), model="AAA", lambda="auto", damped=T)
# 
# #This is the snaive model formulated as an arima model so that it is compatible with sim code below
# #ARIMA <- Arima(CASES+1, order=c(1,1,0), seasonal=c(1,1,2), lambda="auto", biasadj = T)
# #summary(SARIMA)
# 
# MODS <- mix(DDATASET, H=(HW + 1) * 7, CORES=nCores[1]-1)
# print(MODS)
# 
# auto_sarima_par <- read.csv('../Daily_test_Kai/SARIMA_vs_auto.csv')
# 
# foreach(i=1:L.CODES) %dopar% {
#   library("ggplot2")
#   library("forecast")
#   
#   #i<-1
#   #Get daily data for focal region
#   DDATASET <- subset(DDATASET, DDATASET$region == CODES[i], select=c("date", "cases"))
#   DDATASET$date <- as.Date(DDATASET$date)
#   
#   #Extract dates and case numbers
#   DDATES <- as.Date(DDATASET$date)
#   DCASES <- DDATASET$cases
#   
#   #Cast the case counts as a timeseries with weekly frequency
#   DCASES <- ts(DCASES, start=c(2020, as.numeric(format(DDATES[1], "%j"))),
#                frequency = 7)
#   
#   #Calculate raw forecast errors for different methods via rolling CV
#   H = (HW + 1) * 7
#   source('F:/Research/where2test/forecastw2t/R/models.R')
#   ERR.NA <- tsCV(DCASES, fnaive, h = H, initial=1)
#   ERR.HT <- tsCV(DCASES, fholt, h = H, initial=1)
#   ERR.AA <- tsCV(DCASES, farima, h = H, initial=1)
#   ERR.A1 <- tsCV(DCASES, farima110, h = H, initial=1)
#   ERR.CB <- tsCV(DCASES, combination, h = H, m=MODS[i, 2], tests=FALSE, bct=TRUE, initial=1)
#   fsarima <- function(x, h){
#     forecast(Arima(x+1, order=c(0,1,2),seasonal=c(0,1,1),lambda="auto"), h, level=c(95))
#   }
#   ERR.SA <- tsCV(DCASES, fsarima, h = H, initial=1)
#   fsarima_auto <- function(x, h){
#     forecast(Arima(x+1, order=c(as.numeric(strsplit(auto_sarima_par$order[i], ',')[[1]])), 
#                    seasonal=c(as.numeric(strsplit(auto_sarima_par$seasonal[i], ',')[[1]])), 
#                    lambda=auto_sarima_par$lambda[i]), h, level=c(95))
#   }
#   ERR.SA_auto <- tsCV(DCASES, fsarima_auto, h = H, initial=1)
#   
#   #Calculate MAPE for different methods
#   source('F:/Research/where2test/forecastw2t/R/errorplots.R')
#   MAPE.NA <- mape(ERR.NA, DDATASET$cases)
#   MAPE.HT <- mape(ERR.HT, DDATASET$cases)
#   MAPE.AA <- mape(ERR.AA, DDATASET$cases)
#   MAPE.A1 <- mape(ERR.A1, DDATASET$cases)
#   MAPE.CB <- mape(ERR.CB, DDATASET$cases)
#   MAPE.SA <- mape(ERR.SA, DDATASET$cases)
#   MAPE.SA_auto <- mape(ERR.SA_auto, DDATASET$cases)
#   
#   #Create data frame for plotting MAPE by prediction step
#   DF <- data.frame(h = 1:H,
#                    err.na = MAPE.NA,
#                    err.ht = MAPE.HT,
#                    err.aa = MAPE.AA,
#                    err.a1 = MAPE.A1,
#                    err.cb = MAPE.CB,
#                    err.sa = MAPE.SA,
#                    err.sa_auto = MAPE.SA_auto
#   )
#   
#   #Plot MAPE by prediction step
#   TITLE <- paste0("region=", CODES[i])
#   P2 <- ggplot(DF, aes(x = 1:H, y = value, color = variable)) +
#     
#     geom_point(aes(y = err.na, col = "y1"), size=2) +
#     geom_point(aes(y = err.ht, col = "y2"), size=2) +
#     geom_point(aes(y = err.aa, col = "y3"), size=2) +
#     geom_point(aes(y = err.a1, col = "y4"), size=2) +
#     geom_point(aes(y = err.cb, col = "y5"), size=2) +
#     geom_point(aes(y = err.sa, col = "y6"), size=2) +
#     geom_point(aes(y = err.sa_auto, col = "y7"), size=2) +
#     
#     geom_line(aes(y = err.na, col = "y1")) +
#     geom_line(aes(y = err.ht, col = "y2")) +
#     geom_line(aes(y = err.aa, col = "y3")) +
#     geom_line(aes(y = err.a1, col = "y4")) +
#     geom_line(aes(y = err.cb, col = "y5")) +
#     geom_line(aes(y = err.sa, col = "y6")) +
#     geom_line(aes(y = err.sa_auto, col = "y7")) +
#     
#     labs(x = "Forecast horizon (days)",
#          y = "Mean absolute percentage error") +
#     
#     theme(axis.title=element_text(size=14)) +
#     
#     scale_color_discrete(
#       name = "Method:",
#       labels = c("Naive", "Holt", "AutoArima", "Arima110", "Combination", "SARIMA", "SARIMA_auto")
#     ) +
#     ggtitle(TITLE) +
#     theme(plot.title = element_text(lineheight = 0.8, size = 16))
#   
#   #Write error plots to disk
#   ggsave(plot = P2,
#          filename = file.path("F:/Research/where2test/com.casus.env.where2test.forecasting/Daily_test_Kai/Figures/Error_Plots", paste0("Error_Daily", CODES[i], ".png")),
#          device = "png")
# }
# stopCluster(cl)

#Weekly error
registerDoParallel(cl)
# #Get the mix parameter estimates for the current data file
# #Set number of processor cores (CORES) appropriately for your machine
# MODS <- mix(DATA, H=4, CORES=nCores[1]-1)
# 
# #Get the forecasts for the current data file, conditional on appropriate mix param estimates
# #Set number of processor cores (CORES) appropriately for your machine
# FORECASTS <- forecastW2T(DATA, H=4, MODS, CORES=nCores[1]-1)
# 
# #Write the forecasts to file, choosing the output names as appropriate
# write.csv(FORECASTS, file=paste0("F:/Research/where2test/com.casus.env.where2test.forecasting/Daily_test_Kai/Figures/Error_Plots/Saxony_Cases_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F)
# stopCluster(cl)
MODS <- mix(WDATA, 4, BCT = T, CORES = nCores[1]-1)
print(MODS)

DDATASET <- subset(DDATA, select=c("region", "date", "cases"))
DDATASET$date <- as.Date(DDATASET$date)
DDATASET <- DDATASET[DDATASET$date > as.Date('2020-09-13'),]

auto_sarima_par <- read.csv('../Daily_test_Kai/SARIMA_vs_auto.csv')

# MODS_daily <- mix_daily(DDATASET, 28, BCT = T, CORES = nCores[1]-1)
# This code does not work??

X <- DDATASET
H <- 28
BCT <- TRUE
TESTS <- FALSE
#Extract the region codes from the data
CODES <- unique(X$region)

MODS_daily <- foreach(i=CODES, .combine='rbind', .packages="forecast") %dopar% {
  #library("forecast")
  source('F:/Research/where2test/forecastw2t/R/errorplots.R')
  print(i)
  #Extract data for focal region
  DATASET <- subset(X, X$region == i, select=c("date", "cases"))
  
  #Extract dates and case numbers
  DDATES <- as.Date(DATASET$date)
  DCASES <- DATASET$cases
  DCASES <- ts(DCASES, start=c(2020, as.numeric(format(DDATES[1], "%j"))),
               frequency = 7)
  #Create an empty vector to store optimization results
  RES <- c()
  
  #Grid search over values of the mixing parameter, m, in the combination forecast model
  for(j in seq(0, 1, 0.05)){
    
    #Calculate the raw prediction errors by rolling cross-validation
    #CV starts at week 28, which is at the beginning of the second wave
    CVE <- tsCV(DCASES, combination_daily, h = 28, m=j, tests=TESTS, bct=BCT, initial=1)
    
    #Error metric to minimize
    #Mean absolute prediction error, MAPE
    ERR <- mape(CVE, DCASES)
    
    #Store model parameters and resulting error value
    RES <- rbind(RES, c(j, sum(ERR)))
    
  }
  
  #Identify and store the parameters associated with the min error
  MINROW <- which.min(RES[,2])
  MINM <- RES[MINROW, 1]
  
  #Create data structure to return to MODS
  c(i, MINM)
}
print(MODS_daily)


#Extract dates and case numbers
DDATES <- as.Date(head(DDATASET$date, n=-6))
DCASES <- head(DDATASET$cases, n=-6)

#Cast the case counts as a timeseries with weekly frequency
DCASES <- ts(DCASES, start=c(2020, as.numeric(format(DDATES[1], "%j"))),
             frequency = 7)

foreach(i=1:L.CODES) %dopar% {
  library("ggplot2")
  library("forecast")
  
  #i<-1
  #Get daily data for focal region
  WDATASET <- subset(WDATA, WDATA$region == CODES[i], select=c("date", "cases"))
  #Extract dates and case numbers
  WDATES <- as.Date(WDATASET$date)
  WCASES <- WDATASET$cases
  
  #Cast the case counts as a timeseries with weekly frequency
  WCASES <- ts(WCASES, start=c(2020, as.numeric(format(WDATES[1], "%j"))),
               frequency = 52)
  
  DDATASET <- subset(DDATASET, DDATASET$region == CODES[i], select=c("date", "cases"))
  
  #Extract dates and case numbers
  DDATES <- as.Date(head(DDATASET$date, n=-6))
  DCASES <- head(DDATASET$cases, n=-6)
  
  #Cast the case counts as a timeseries with weekly frequency
  DCASES <- ts(DCASES, start=c(2020, as.numeric(format(DDATES[1], "%j"))),
               frequency = 7)
  
  #Calculate raw forecast errors for different methods via rolling CV
  H = 4
  source('F:/Research/where2test/forecastw2t/R/models.R')
  ERR.NA <- tsCV(WCASES, fnaive, h = H, initial=28)
  ERR.HT <- tsCV(WCASES, fholt, h = H, initial=28)
  ERR.AA <- tsCV(WCASES, farima, h = H, initial=28)
  ERR.A1 <- tsCV(WCASES, farima110, h = H, initial=28)
  ERR.CB <- tsCV(WCASES, combination, h = H, m=MODS[i, 2], tests=FALSE, bct=TRUE, initial=28)
  H = (HW + 1) * 7
  fsarima <- function(x, h){
    forecast(Arima(x+1, order=c(0,1,2),seasonal=c(0,1,1),lambda="auto"), h, level=c(95))
  }
  ERR.SA <- tsCV(DCASES, farima, h = H, initial=1)
  fsarima_auto <- function(x, h){
    forecast(Arima(x+1, order=c(as.numeric(strsplit(auto_sarima_par$order[i], ',')[[1]])), 
                   seasonal=c(as.numeric(strsplit(auto_sarima_par$seasonal[i], ',')[[1]])), 
                   lambda=auto_sarima_par$lambda[i]), h, level=c(95))
  }
  ERR.SA_auto <- tsCV(DCASES, fsarima_auto, h = H, initial=1)
  ERR.SH_a <- tsCV(DCASES, fholt_a, h = H, initial=1)
  ERR.SH_m <- tsCV(DCASES, fholt_m, h = H, initial=1)
  ERR.CB_d <- tsCV(DCASES, combination_daily, h = H, m=MODS_daily[i, 2], tests=FALSE, bct=TRUE, initial=1)
  ERR.HT_d <- tsCV(DCASES, fholt, h = H, initial=1)
  
  #Calculate MAPE for different methods
  source('F:/Research/where2test/forecastw2t/R/errorplots.R')
  MAPE.NA <- mape(ERR.NA, WDATASET$cases)
  MAPE.HT <- mape(ERR.HT, WDATASET$cases)
  MAPE.AA <- mape(ERR.AA, WDATASET$cases)
  MAPE.A1 <- mape(ERR.A1, WDATASET$cases)
  MAPE.CB <- mape(ERR.CB, WDATASET$cases)
  MAPE.SA <- mape(ERR.SA, DDATASET$cases)
  MAPE.SA_auto <- mape(ERR.SA_auto, DDATASET$cases)
  MAPE.SH_a <- mape(ERR.SH_a, DDATASET$cases)
  MAPE.SH_m <- mape(ERR.SH_m, DDATASET$cases)
  MAPE.CB_d <- mape(ERR.CB_d, DDATASET$cases)
  MAPE.HT_d <- mape(ERR.HT_d, DDATASET$cases)
  
  #Create data frame for plotting MAPE by prediction step
  DF <- data.frame(h = seq(1,H,7),
                   err.na = MAPE.NA,
                   err.ht = MAPE.HT,
                   err.aa = MAPE.AA,
                   err.a1 = MAPE.A1,
                   err.cb = MAPE.CB)
  
  DF_day <- data.frame(h = 1:28,
                   err.sa = MAPE.SA,
                   err.sa_auto = MAPE.SA_auto,
                   err.sh_a = MAPE.SH_a,
                   err.sh_m = MAPE.SH_m,
                   err.cb_d = MAPE.CB_d,
                   err.ht_d = MAPE.HT_d
  )
  
  DF <- merge(DF,DF_day,by='h',all = TRUE)
  
  write.csv(DF,paste("F:/Research/where2test/com.casus.env.where2test.forecasting/Daily_test_Kai/Figures/Error_Plots/Error_Weekly", CODES[i], ".csv",sep=''))
  
  #Plot MAPE by prediction step
  TITLE <- paste0("region=", CODES[i])
  P2 <- ggplot(DF, aes(x = 1:H, y = value, color = variable)) +
    
    geom_point(aes(y = err.na, col = "y1"), size=2) +
    geom_point(aes(y = err.ht, col = "y2"), size=2) +
    geom_point(aes(y = err.aa, col = "y3"), size=2) +
    geom_point(aes(y = err.a1, col = "y4"), size=2) +
    geom_point(aes(y = err.cb, col = "y5"), size=2) +
    geom_point(aes(y = err.sa, col = "y6"), size=2) +
    geom_point(aes(y = err.sa_auto, col = "y7"), size=2) +
    geom_point(aes(y = err.sh_a, col = "y8"), size=2) +
    geom_point(aes(y = err.sh_m, col = "y9"), size=2) +
    geom_point(aes(y = err.cb_d, col = "y10"), size=2) +
    geom_point(aes(y = err.ht_d, col = "y11"), size=2) +
    
    geom_line(data=DF[!is.na(DF$err.na),], aes(x = h, y = err.na, col = "y1")) +
    geom_line(data=DF[!is.na(DF$err.ht),], aes(x = h, y = err.ht, col = "y2")) +
    geom_line(data=DF[!is.na(DF$err.aa),], aes(x = h, y = err.aa, col = "y3")) +
    geom_line(data=DF[!is.na(DF$err.a1),], aes(x = h, y = err.a1, col = "y4")) +
    geom_line(data=DF[!is.na(DF$err.cb),], aes(x = h, y = err.cb, col = "y5")) +
    geom_line(aes(y = err.sa, col = "y6")) +
    geom_line(aes(y = err.sa_auto, col = "y7")) +
    geom_line(aes(y = err.sh_a, col = "y8")) +
    geom_line(aes(y = err.sh_m, col = "y9")) +
    geom_line(aes(y = err.cb_d, col = "y10")) +
    geom_line(aes(y = err.ht_d, col = "y11")) +
    
    labs(x = "Forecast horizon (days)",
         y = "Mean absolute percentage error") +
    
    scale_y_continuous(trans='log10') +
    
    theme(axis.title=element_text(size=14)) +
    
    scale_color_discrete(
      name = "Method:",
      breaks = c('y1','y2','y3','y4','y5','y6','y7','y8','y9','y10','y11'),
      labels = c("Naive", "Holt", "AutoArima", "Arima110", "Combination", "SARIMA", "SARIMA_auto", 
                 "SHolt_additive", "SHolt_multiplicative", "SCombination_daily", "Holt_daily")
    ) +
    ggtitle(TITLE) +
    theme(plot.title = element_text(lineheight = 0.8, size = 16))
  
  #Write error plots to disk
  ggsave(plot = P2,
         filename = file.path("F:/Research/where2test/com.casus.env.where2test.forecasting/Daily_test_Kai/Figures/Error_Plots", paste0("Error_Weekly", CODES[i], ".png")),
         device = "png")
}



HW_selection <- foreach(i=CODES, .combine='rbind', .packages="forecast") %dopar% {
  #library("forecast")
  source('F:/Research/where2test/forecastw2t/R/errorplots.R')
  print(i)
  #Extract data for focal region
  DATASET <- subset(X, X$region == i, select=c("date", "cases"))
  
  #Extract dates and case numbers
  DDATES <- as.Date(DATASET$date)
  DCASES <- DATASET$cases
  DCASES <- ts(DCASES, start=c(2020, as.numeric(format(DDATES[1], "%j"))),
               frequency = 7)
  fit <- ets(DCASES, model = "ZZZ", damped = TRUE)
  c(i, fit$method, fit$aicc, fit$par[1:3])
}
write.csv(HW_selection,"F:/Research/where2test/com.casus.env.where2test.forecasting/Daily_test_Kai/HW.csv")
#Additive Holt-Winters' method was selected
stopCluster(cl)