library("foreach")
library("doParallel")

source('D:/Research/where2test/com.casus.env.where2test.forecasting/Daily_test_Kai/Kai_functions.R')

#Register a cluster for parallelized loop
nCores <- detectCores()
cl<- makeCluster(nCores[1]-1) #not to overload your computer
registerDoParallel(cl)

setwd("D:/Research/where2test/com.casus.env.where2test.forecasting/TestSarima/")


#Weekly data
WDATA <- read.csv(file="Data/cases[RKI]_saxony_weekly.csv")
WDATA$date <- as.Date(WDATA$date)
WDATA <- WDATA[WDATA$region=='14000',]
WDATA <- WDATA[WDATA$date < "2021-11-21",]


CODES <- unique(WDATA$region)
L.CODES <- length(CODES)
NOBS <- 100

#Number of sims. This should be large #(to reduce the simulation time, change 10000 to 100)
NREP <- 10000

#This is how many days of data will be ignored at the end of the dataset
HDNC <- 4

#Length of the forecast horizon in weeks, excluding nowcast
HW <- 3

#Overall forecast horizon in days including nowcast
HD <- HW*7 + HDNC
#WDATA$pred <- NA

library(forecastW2T)
MODS <- mix(WDATA, 4, BCT = T, CORES = nCores[1]-1)
print(MODS)
MODS <- t(data.frame(MODS))
stopCluster(cl) 
df <- forecastW2T(WDATA,4,MODS, BCT=TRUE, nCores[1]-1)

DATA <- read.csv(file="Data/cases[RKI]_saxony_weekly.csv", sep=",")
FORECAST <- df #read.csv(file=paste("Predictions/Combine",i,"14000", sep="_"), sep=",")
#DATA <- DATA[DATA$date > '2021-10-01',]
#FORECAST <- FORECAST[FORECAST$date > '2021-10-01',]
sachsen <- DATA[DATA$region=="14000" & DATA$date < as.Date("2021-11-21"),]
#sachsen <- sachsen[-nrow(sachsen),]
sachsenForecast <- FORECAST[FORECAST$region=="14000",]
sachsenPopulation <- 4056941

plotcasesSachsenSarima<-ggplot(sachsenForecast, 
                               aes(x = as.Date(date, format =  "%Y-%m-%d"), y = m/sachsenPopulation * 1e5))+ 
  #geom_line(color = "black", size = 0.8) + 
  geom_line(data = sachsenForecast, aes(x = as.Date(date, format =  "%Y-%m-%d"), y = m/sachsenPopulation * 1e5, color = "forecast"), size = 1) +
  geom_ribbon(data = sachsenForecast, aes(ymin = l95/sachsenPopulation * 1e5, ymax=u95/sachsenPopulation * 1e5),alpha=.25) +
  geom_point(data= sachsen, aes(x = as.Date(date, format =  "%Y-%m-%d"), y = cases/sachsenPopulation * 1e5), color = "black", size = 2) +
  labs(x = "2020-2022", y = "infected") +
  scale_x_date(date_breaks = "2 month", date_minor_breaks = "2 week",
               date_labels = "%B") +
  #ylim(0,max(max(sachsenForecast$u95/sachsenPopulation * 1e5, na.rm = TRUE),
  #           max(sachsen$cases/sachsenPopulation * 1e5)))+
  theme(axis.title.x = element_text(margin = margin(t = 10), size = 20),
        axis.title.y = element_text(margin = margin(r = 10), size = 20),
        axis.text = element_text(color = "black", size = 16),
        axis.text.x = element_text(face = "italic", angle = 45, vjust = 1, hjust = 1),
        axis.ticks.length=unit(-0.25, "cm")) +
  ggtitle("infected versus date for weekly case of Sachsen per 100.000")

plotcasesSachsenSarima


