#library("remotes")
#remotes::install_gitlab("calabr29/forecastw2t@2-check-the-outburst-on-the-peak-cases", host="gitlab.hzdr.de", auth_token="Nbyh89kzgRty5ftGsMxK", force = TRUE)
library("forecastW2T")

args=commandArgs(trailingOnly=TRUE)

# test if there is at least one argument: if not, return an error
if (length(args)==0) {
  stop("At least one argument must be supplied", call.=FALSE)
}

setwd("/bigdata/hplsim/production/nu_urang/where2test/com.casus.env.where2test.forecasting/")
getwd()
nCores <- 8

DIR <- as.integer(args[1])
switch(DIR,
			 setwd("Week_2022_01_05/forecasts_saxony_cases/"),
			 setwd("Week_2022_01_12/forecasts_saxony_cases/"),
			 setwd("Week_2022_01_19/forecasts_saxony_cases/"),
			 setwd("Week_2022_01_26/forecasts_saxony_cases/"),
			 setwd("Week_2022_02_02/forecasts_saxony_cases/"),
			 setwd("Week_2022_02_09/forecasts_saxony_cases/"),
			 setwd("Week_2022_02_16/forecasts_saxony_cases/"),
			 setwd("Week_2022_02_23/forecasts_saxony_cases/"),
			 setwd("Week_2022_03_02/forecasts_saxony_cases/"),
			 setwd("Week_2022_03_09/forecasts_saxony_cases/"),
			 setwd("Week_2022_03_16/forecasts_saxony_cases/"),
			 setwd("Week_2022_03_23/forecasts_saxony_cases/"),
			 setwd("Week_2022_03_30/forecasts_saxony_cases/"),
			 setwd("Week_2022_04_06/forecasts_saxony_cases/"),
			 setwd("Week_2022_04_13/forecasts_saxony_cases/"),
			 setwd("Week_2022_04_20/forecasts_saxony_cases/"),
			 setwd("Week_2022_04_27/forecasts_saxony_cases/"),
			 setwd("Week_2022_05_04/forecasts_saxony_cases/"),
			 setwd("Week_2022_05_11/forecasts_saxony_cases/"),
			 setwd("Week_2022_05_18/forecasts_saxony_cases/")
)

if (!dir.exists("Figures")) {dir.create("Figures")}
if (!dir.exists("Error_Plots")) {dir.create("Error_Plots")}

DATAW <- read.csv(file="casesrki_saxony_weekly.csv")
DATAD <- read.csv(file="cases[RKI]_saxony_daily.csv")

MODSW <- mix(DATAW, H=4, CORES=nCores)

FTYPE <- as.integer(args[2])

switch (FTYPE,
				FORECAST <- forecastW2T_weekly_Now_4week(DATAD, DATAW, H=4, MODS_daily=MODSW, BCT=FALSE, CORES=nCores, MODS=MODSW, training_length=150),
				FORECAST <- forecastW2T_weekly_Now_4week(DATAD, DATAW, H=4, MODS_daily=MODSW, BCT=TRUE, CORES=nCores, MODS=MODSW, training_length=150),
				FORECAST <- forecastW2T_daily_5week(DATAD, DATAW, H=4, MODS_daily=MODSW, BCT=FALSE, CORES=nCores, MODS=MODSW, training_length=150),
				FORECAST <- forecastW2T_daily_5week(DATAD, DATAW, H=4, MODS_daily=MODSW, BCT=TRUE, CORES=nCores, MODS=MODSW, training_length=150),
				FORECAST <- forecastW2T_daily_double_latest_non_zero(DATAD, DATAW, H=4, MODS_daily=MODSW, BCT=FALSE, CORES=nCores, MODS=MODSW, training_length=150),
				FORECAST <- forecastW2T_daily_double_latest_non_zero(DATAD, DATAW, H=4, MODS_daily=MODSW, BCT=TRUE, CORES=nCores, MODS=MODSW, training_length=150),
				FORECAST <- forecastW2T_daily(DATAD, DATAW, H=4, MODS_daily=MODSW, BCT=FALSE, CORES=nCores, MODS=MODSW, training_length=150),
				FORECAST <- forecastW2T_daily(DATAD, DATAW, H=4, MODS_daily=MODSW, BCT=TRUE, CORES=nCores, MODS=MODSW, training_length=150)
)

switch (FTYPE,
				write.csv(FORECAST, file=paste0("Saxony_Cases_Forecast_Daily_n4wf.csv"), row.names=F),
				write.csv(FORECAST, file=paste0("Saxony_Cases_Forecast_Daily_n4wt.csv"), row.names=F),
				write.csv(FORECAST, file=paste0("Saxony_Cases_Forecast_Daily_5wf.csv"), row.names=F),
				write.csv(FORECAST, file=paste0("Saxony_Cases_Forecast_Daily_5wt.csv"), row.names=F),
				write.csv(FORECAST, file=paste0("Saxony_Cases_Forecast_Daily_doubleF.csv"), row.names=F),
				write.csv(FORECAST, file=paste0("Saxony_Cases_Forecast_Daily_doubleT.csv"), row.names=F),
				write.csv(FORECAST, file=paste0("Saxony_Cases_Forecast_DailyF.csv"), row.names=F),
				write.csv(FORECAST, file=paste0("Saxony_Cases_Forecast_DailyT.csv"), row.names=F)
)
