library('RPostgres')
library('dplyr')
library('ggplot2')
library('KernSmooth')
library('sys')
#library("remotes")
#remotes::install_gitlab("calabr29/forecastw2t", host="gitlab.hzdr.de", auth_token="Nbyh89kzgRty5ftGsMxK", force = TRUE)
library("forecastW2T")

args=commandArgs(trailingOnly=TRUE)

# test if there is at least one argument: if not, return an error
if (length(args)==0) {
  stop("At least one argument must be supplied", call.=FALSE)
}

setwd("~/")
w2tforecasting <- paste("Workspaces", "com.casus.env.where2test.forecasting", sep="/")
setwd(w2tforecasting)
getwd()
today <- Sys.Date()
date <- format(today, format="%Y_%m_%d")
folder_name <- paste("Week", date, sep="_")
print(folder_name)
if (!dir.exists(folder_name)) {dir.create(folder_name)}

setwd(folder_name)
#connections
con <- dbConnect(drv = Postgres(),
                 user = "where2test",
                 password = "P4rtyP4rr0t",
                 host = "where2testadm.hzdr.de",
                 port = 32771,
                 dbname="db_where2test"
)

sql_querry <- paste ("select", "*", "from", args[1], ";", sep=" ")

print("csv file created. Forecasting process is running")
#set dataframe using the querry of sql
DATA <- dbGetQuery(con, sql_querry)

if (!dir.exists(args[2])) {dir.create(args[2])}

setwd(args[2])
filename <- paste(substr(args[1], 6, nchar(args[1])), "csv", sep=".")
write.csv(DATA, filename, row.names = FALSE)
dbDisconnect(con)

#Create necessary directories for storing results
if (!dir.exists("Forecasts")) {dir.create("Forecasts")}
setwd("Forecasts")
if (!dir.exists("Data")) {dir.create("Data")}
if (!dir.exists("Forecasts")) {dir.create("Forecasts")}
if (!dir.exists("Error_Plots")) {dir.create("Error_Plots")}
if (!dir.exists("Forecast_Plots")) {dir.create("Forecast_Plots")}

#Choose what you want to predict. Again, you must recreate the above-created
#directories for each set of predictions
#Set TARGET <- 1 for Saxony cases
#Set TARGET <- 2 for Czechia cases
#Set TARGET <- 3 for Czechia tests
#Set TARGET <- 4 for Saxony vaccine
TARGET <- as.integer(args[3])
print(paste("Target No", TARGET, sep=" "))
home <- paste("/home", "wildan", sep="/")
INPATH = paste(home, w2tforecasting, folder_name,args[2], filename, sep="/")
print(INPATH)
DATAREAD <- read.csv(file=INPATH)

#Get the mix parameter estimates for the current data file
#Set number of processor cores (CORES) appropriately for your machine
MODS <- mix(DATAREAD, H=4, CORES=8)

#Get the forecasts for the current data file, conditional on appropriate mix param estimates
#Set number of processor cores (CORES) appropriately for your machine
FORECASTS <- forecastW2T(DATAREAD, H=4, MODS, CORES=8)
OUTPATH <- paste(home, w2tforecasting, folder_name,args[2], sep="/")
switch(TARGET,
       write.csv(FORECASTS, file=paste0(OUTPATH, "/Saxony_Cases_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0(OUTPATH, "/Czechia_Cases_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0(OUTPATH, "/Czechia_Tests_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0(OUTPATH, "/Saxony_Vaccination_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0(OUTPATH, "/Bundesland_Hospital_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0(OUTPATH, "/Dolnoslaski_Cases_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F)
)

