detach("package:forecastW2T", unload = TRUE)
library("remotes")
#library("devtools")
remotes::install_gitlab("calabr29/forecastw2t@develop", host="gitlab.hzdr.de", auth_token="Nbyh89kzgRty5ftGsMxK", force = TRUE)
#setwd("C:/Workspaces")
#devtools::install("forecastW2T")
library("forecastW2T")
library("doParallel")

#Set base directory
setwd("C:/Workspaces/com.casus.env.where2test.forecasting/TestSarima")
nCores <- detectCores()
cl<- makeCluster(nCores[1]-1) #not to overload your computer
#Create necessary directories for storing results
#if (!dir.exists("Forecasts")) {dir.create("Forecasts")}
#setwd("Forecasts")
#if (!dir.exists("Data")) {dir.create("Data")}
#if (!dir.exists("Forecasts")) {dir.create("Forecasts")}
if (!dir.exists("Error_Plots")) {dir.create("Error_Plots")}
#if (!dir.exists("Forecast_Plots")) {dir.create("Forecast_Plots")}

#NOTE: PUT APPROPRIATE DATA FILE (EITHER SAXONY CASES, CZECHIA CASES, OR CZECHIA
#TESTS) IN "Forecasts/Data" BEFORE PROCEEDING FROM HERE

#NOTE: ONLY RUN ONE SET OF PREDICTIONS IN THE ABOVE CREATED DIRECTORIES.
#FOR EXAMPLE, AFTER DOING PREDICTIONS FOR SAXONY CASES, YOU'D CHANGE THE NAME
#OF THE FORECASTS DIRECTORY (THIS IS DONE AUTOMATICALLY BELOW), THEN RECREATE
#ALL OF THE ABOVE DIRECTORIES, STARTING BY SETTING THE BASE DIRECTORY, BEFORE
#DOING FORECASTS FOR THE NEXT DATASET (E.G., CZECH CASES)

#Choose what you want to predict. Again, you must recreate the above-created
#directories for each set of predictions
#Set TARGET <- 1 for Saxony cases
#Set TARGET <- 2 for Czechia cases
#Set TARGET <- 3 for Czechia tests
TARGETW <- 1
TARGETD <- 1

#Read in a data file. Do this only one at a time
switch(TARGETW,
       DATAW <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/TestSarima/Data/cases[RKI]_saxony_weekly.csv"),
       DATA <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/Week_1711/forecasts_czechia_cases/cases_czechia_weekly.csv"),
       DATA <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/Week_1711/forecasts_czechia_tests/tests_czechia_weekly.csv"),
       DATA <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/Week_1711/forecasts_vaccinations/vaccination-rate[RKI]_germany_kreis_weekly.csv"),

)

#Read in a data file. Do this only one at a time
switch(TARGETD,
       DATAD <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/TestSarima/Data/cases[RKI]_saxony_daily.csv"),
       DATA <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/Week_1711/forecasts_czechia_cases/cases_czechia_weekly.csv"),
       DATA <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/Week_1711/forecasts_czechia_tests/tests_czechia_weekly.csv"),
       DATA <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/Week_1711/forecasts_vaccinations/vaccination-rate[RKI]_germany_kreis_weekly.csv"),

)

zero_days <- function(df){
  tmp <- df[df$region==unique(df$region)[1],'cases']
  d <- 1
  while (sum(tail(tmp,n=d))==0){
    d = d + 1
  }
  return(d)
}

FILTERDATAD <- subset(DATAD, as.Date(date) < Sys.Date() - zero_days(DATAD)  &  as.Date(date) >= Sys.Date() - 100)

#Get the mix parameter estimates for the current data file
#Set number of processor cores (CORES) appropriately for your machine
MODS <- mix_daily(FILTERDATAD, H=28, CORES=cl)
MODSW <- mix(DATAW, H=4, CORES=cl)

#Get the forecasts for the current data file, conditional on appropriate mix param estimates
#Set number of processor cores (CORES) appropriately for your machine
FORECASTS <- forecastW2T_daily(DATAD, DATAW, H=4, MODS_daily=MODS, CORES=cl, MODS=MODSW)

#Write the forecasts to file, choosing the output names as appropriate
switch(TARGETD,
       write.csv(FORECASTS, file=paste0("C:/Workspaces/com.casus.env.where2test.forecasting/TestSarima/Saxony_Cases_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0("C:/Workspaces/com.casus.env.where2test.forecasting/Week_1711/forecasts_czechia_cases/Czechia_Cases_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0("C:/Workspaces/com.casus.env.where2test.forecasting/Week_1711/forecasts_czechia_tests/Czechia_Tests_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0("C:/Workspaces/com.casus.env.where2test.forecasting/Week_1711/forecasts_czechia_tests/Vaccination_Rate_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F)
)

#Rename the Forecasts directory as appropriate.
#switch(TARGET,
       #file.rename("../Forecasts", paste0("../Forecasts_Saxony_Cases_", toString(Sys.Date()))),
       #("../Forecasts", paste0("../Forecasts_Czechia_Cases_", toString(Sys.Date()))),
       #file.rename("../Forecasts", paste0("../Forecasts_Czechia_Tests_", toString(Sys.Date())))
#)
