library("remotes")

remotes::install_gitlab("calabr29/forecastw2t", host="gitlab.hzdr.de", auth_token="Nbyh89kzgRty5ftGsMxK")

library("forecastW2T")

#Set base directory
setwd("C:/Workspaces/com.casus.env.where2test.forecasting/Week_2411/forecasts_czechia_cases/")

#Create necessary directories for storing results
if (!dir.exists("Forecasts")) {dir.create("Forecasts")}
setwd("Forecasts")
if (!dir.exists("Data")) {dir.create("Data")}
if (!dir.exists("Forecasts")) {dir.create("Forecasts")}
if (!dir.exists("Error_Plots")) {dir.create("Error_Plots")}
if (!dir.exists("Forecast_Plots")) {dir.create("Forecast_Plots")}

#NOTE: PUT APPROPRIATE DATA FILE (EITHER SAXONY CASES, CZECHIA CASES, OR CZECHIA
#TESTS) IN "Forecasts/Data" BEFORE PROCEEDING FROM HERE

#NOTE: ONLY RUN ONE SET OF PREDICTIONS IN THE ABOVE CREATED DIRECTORIES.
#FOR EXAMPLE, AFTER DOING PREDICTIONS FOR SAXONY CASES, YOU'D CHANGE THE NAME
#OF THE FORECASTS DIRECTORY (THIS IS DONE AUTOMATICALLY BELOW), THEN RECREATE
#ALL OF THE ABOVE DIRECTORIES, STARTING BY SETTING THE BASE DIRECTORY, BEFORE
#DOING FORECASTS FOR THE NEXT DATASET (E.G., CZECH CASES)

#Choose what you want to predict. Again, you must recreate the above-created
#directories for each set of predictions
#Set TARGET <- 1 for Saxony cases
#Set TARGET <- 2 for Czechia cases
#Set TARGET <- 3 for Czechia tests
TARGET <- 2

#Read in a data file. Do this only one at a time
switch(TARGET,
       DATA <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/Week_2411/forecasts_saxony_cases/cases[RKI]_saxony_weekly.csv"),
       DATA <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/Week_2411/forecasts_czechia_cases/cases_czechia_weekly.csv"),
       DATA <- read.csv(file="C:/Workspaces/com.casus.env.where2test.forecasting/Week_2411/forecasts_czechia_tests/tests_czechia_weekly.csv")
)


#Get the mix parameter estimates for the current data file
#Set number of processor cores (CORES) appropriately for your machine
MODS <- mix(DATA, H=4, CORES=8)

#Get the forecasts for the current data file, conditional on appropriate mix param estimates
#Set number of processor cores (CORES) appropriately for your machine
FORECASTS <- forecastW2T(DATA, H=4, MODS, CORES=8)

#Write the forecasts to file, choosing the output names as appropriate
switch(TARGET,
       write.csv(FORECASTS, file=paste0("C:/Workspaces/com.casus.env.where2test.forecasting/Week_2411/forecasts_saxony_cases/Saxony_Cases_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0("C:/Workspaces/com.casus.env.where2test.forecasting/Week_2411/forecasts_czechia_cases/Czechia_Cases_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F),
       write.csv(FORECASTS, file=paste0("C:/Workspaces/com.casus.env.where2test.forecasting/Week_2411/forecasts_czechia_tests/Czechia_Tests_Forecasts_", toString(Sys.Date()), ".csv"), row.names = F)
)

#Rename the Forecasts directory as appropriate.
#switch(TARGET,
       #file.rename("../Forecasts", paste0("../Forecasts_Saxony_Cases_", toString(Sys.Date()))),
       #("../Forecasts", paste0("../Forecasts_Czechia_Cases_", toString(Sys.Date()))),
       #file.rename("../Forecasts", paste0("../Forecasts_Czechia_Tests_", toString(Sys.Date())))
#)
