library('dplyr')
library('ggplot2')

DATA <- read.csv(file="TestSarima/Data/cases[RKI]_saxony_weekly.csv", sep=",")
FORECAST <- read.csv(file="TestSarima/Predictions/Forecasts/Weekly_14000", sep=",")
sachsen <- DATA[DATA$region=="14000",]
sachsenForecast <- FORECAST[FORECAST$region=="14000",]
sachsenPopulation <- 4056941

plotcasesSachsenSarima<-ggplot(sachsenForecast, 
       aes(x = as.Date(date, format =  "%Y-%m-%d"), y = m/sachsenPopulation * 1e5))+ 
  #geom_line(color = "black", size = 0.8) + 
  geom_line(data = sachsenForecast, aes(x = as.Date(date, format =  "%Y-%m-%d"), y = m/sachsenPopulation * 1e5, color = "forecast"), size = 1) +
  geom_ribbon(data = sachsenForecast, aes(ymin = l95/sachsenPopulation * 1e5, ymax=u95/sachsenPopulation * 1e5),alpha=.25) +
  geom_point(data= sachsen, aes(x = as.Date(date, format =  "%Y-%m-%d"), y = cases/sachsenPopulation * 1e5), color = "black", size = 2) +
  labs(x = "2020-2022", y = "infected") +
  scale_x_date(date_breaks = "2 month", date_minor_breaks = "2 week",
             date_labels = "%B") +
  theme(axis.title.x = element_text(margin = margin(t = 10), size = 20),
        axis.title.y = element_text(margin = margin(r = 10), size = 20),
        axis.text = element_text(color = "black", size = 16),
        axis.text.x = element_text(face = "italic", angle = 45, vjust = 1, hjust = 1),
        axis.ticks.length=unit(-0.25, "cm")) +
  ggtitle("infected versus date for weekly case of Sachsen per 100.000")

plotcasesSachsenSarima
ggsave("sachsenInfectedSarima.png",width = 20, height = 10, units = "cm")